import { Injectable } from '@angular/core'
import { HttpRequest, HttpHandler, HttpEvent, HttpInterceptor } from '@angular/common/http'
import { Observable } from 'rxjs'
import { AuthService } from '../services/auth.service'

@Injectable()
export class JwtInterceptor implements HttpInterceptor {
    constructor(private _authService: AuthService) {}

    intercept(request: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>> {
        const accessToken = this._authService.accessToken
        //const isApiUrl = request.url.startsWith(environment.apiUrl);
        if (accessToken 
            && !request.url.includes("/xapi/statements") 
            && !request.url.includes("/api/v1/provider/data")
            && !request.url.includes("/api/v1/provider/store-result")
            && !request.url.includes("/api/v1/provider/result")) {
            request = request.clone({
                setHeaders: { Authorization: `Bearer ${accessToken}` }
            })
        }

        return next.handle(request)
    }
}
