# Generated by Django 4.1.2 on 2023-02-09 15:33

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Provider",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("definition_id", models.CharField(max_length=255)),
                ("name", models.CharField(max_length=200)),
                ("description", models.TextField()),
                ("updated", models.DateTimeField(auto_now=True)),
                ("created", models.DateTimeField(auto_now_add=True)),
            ],
        ),
        migrations.CreateModel(
            name="ProviderSchema",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("groups", models.JSONField()),
                ("essential_verbs", models.JSONField()),
                ("updated", models.DateTimeField(auto_now=True)),
                ("created", models.DateTimeField(auto_now_add=True)),
                (
                    "provider",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="providers.provider",
                    ),
                ),
                (
                    "superseded_by",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="providers.providerschema",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="ProviderAuthorization",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("key", models.CharField(max_length=200)),
                ("updated", models.DateTimeField(auto_now=True)),
                ("created", models.DateTimeField(auto_now_add=True)),
                (
                    "provider",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="providers.provider",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="AnalyticsToken",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(db_index=True, max_length=64, unique=True)),
                ("key", models.CharField(max_length=200)),
                ("active_verbs", models.JSONField(default=list)),
                ("expires", models.DateTimeField(null=True)),
                ("created", models.DateTimeField(auto_now_add=True)),
                (
                    "can_access",
                    models.ManyToManyField(
                        related_name="result_access", to="providers.analyticstoken"
                    ),
                ),
            ],
        ),
    ]
